function [P,R] = precisionRecall(rankings,C)
% [P,R] = precisionRecall(rankings,C)
%
% David Pickup 2015

Pi = zeros(size(rankings,2),1);
Ri = Pi;
for m = 1:size(rankings,1)
    for i = 1:size(rankings,2)
        Pi(i) = precisionSingle(rankings,C,i,m);
        Ri(i) = recallSingle(rankings,C,i,m);
    end
    [~,ia,~] = unique(Ri);
    sort(ia);
    idx = find(Ri==0);
    ia(ismember(ia,idx)) = [];
    if m == 1
        P = Pi(ia);
        R = Ri(ia);
    else
        P = P + Pi(ia);
        R = R + Ri(ia);
    end
end
R = R./size(rankings,1);
P = P./size(rankings,1);
R = [0;R];
P = [1;P];

return;

function P = precisionSingle(rankings,C,n,m)
idx = find(C(rankings(m,1:n)) == C(m));
P = (numel(idx) / n);
return;

function R = recallSingle(rankings,C,n,m)
idx = find(C==C(m));
nClass = numel(idx)-1;
idx = find(C(rankings(m,1:n)) == C(m));
R = (numel(idx) / nClass);
return;